#include "Events.h"

#define I_AM_ALIVE 	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
	(*iter)->uEventStatus = EVENT_RUNNING; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define STOP_ME 	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
	(*iter)->uEventStatus = EVENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hEventsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define WAIT_FOR_STOP 	BOOL bStop = FALSE; \
	while(bStop == FALSE){ \
	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId && \
	(*iter)->uCommand == EVENT_STOP){ \
	bStop = TRUE; \
	break; \
} \
	} \
	UNLOCK(statusObj->hEventsLock); \
	MiniSleep(500); \
	}

#define CHECK_FOR_STOP	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId \
	&& (*iter)->uCommand == EVENT_STOP){ \
	(*iter)->uEventStatus = EVENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hEventsLock); \
	return TRUE; \
} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define TRIGGER_ACTION(x)	WAIT_AND_SIGNAL(statusObj->hActionsLock); \
	actions = statusObj->GetActionsList(); \
	for(counter = 0, iterA = actions->begin(); iterA != actions->end(); iterA++, counter++){ \
	if(counter == x){ \
	(*iterA)->bTriggered = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hActionsLock);

#define COMMON_DATA(x) 	UINT MyID = x; \
	Status *statusObj = Status::self(); \
	list<EventStruct *>::iterator iter; \
	list<EventStruct *> *events; \
	pEventStruct myData = (pEventStruct)lpParam; \
	list<MacroActionStruct *>::iterator iterA; \
	list<MacroActionStruct *> *actions; \
	UINT counter;

DWORD WINAPI OnTimer(LPVOID lpParam) {
	COMMON_DATA(EVENT_TIMER);
	pTimerStruct myConf = (pTimerStruct)(myData->pParams);
	unsigned __int64 time, tmp_time;
	UINT wait;
	WCHAR pathName[MAX_PATH] = {0};

	// Queste due get servono solo per controllare che statusObj si trovi
	// in uno stato coerente
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		STOP_ME;
	}

	I_AM_ALIVE;

	tmp_time = 0;
	time = GetTime();

	LOOP{
		switch(myConf->uType){
			case CONF_TIMER_SINGLE:
				wait = myConf->Lo_Delay;

				if(DiffTime(GetTime(), time) >= wait){
					TRIGGER_ACTION(myData->uActionId);
					STOP_ME;
				}

				break;
			case CONF_TIMER_REPEAT:
				wait = myConf->Lo_Delay;
				tmp_time = GetTime();

				if(DiffTime(tmp_time, time) >= wait){
					time = tmp_time;
					TRIGGER_ACTION(myData->uActionId);
				}

				break;
			case CONF_TIMER_DATE:
				tmp_time = 0;
				tmp_time = myConf->Hi_Delay;
				tmp_time <<= 32;
				tmp_time |= myConf->Lo_Delay;

				if(GetTime() >= tmp_time){
					TRIGGER_ACTION(myData->uActionId);
					STOP_ME;
				}

				break;
			case CONF_TIMER_DELTA: break;
				// XXX - Da implementare (Lo e Hi sono in FILETIME)
				/*FILETIME cft;
				HANDLE hMod = INVALID_HANDLE_VALUE;
				LARGE_INTEGER c_time;
				GetModuleFileName(NULL, pathName, MAX_PATH);
				hMod = CreateFile(pathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
				GetFileTime(hMod, &cft, NULL, NULL);
				c_time.HighPart = cft.dwHighDateTime;
				c_time.LowPart = cft.dwLowDateTime;
				GetSystemTimeAsFileTime(&t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;*/

				//if(c_time.QuadPart >= myConf->Hi_Delay)
			default: 
				STOP_ME;
				break;
		}

		Sleep(600);
		CHECK_FOR_STOP;
	}

	STOP_ME;
}

DWORD WINAPI OnSms(LPVOID lpParam) {
	COMMON_DATA(EVENT_SMS);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

DWORD WINAPI OnCall(LPVOID lpParam) {
	COMMON_DATA(EVENT_CALL);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

DWORD WINAPI OnConnection(LPVOID lpParam) {
	COMMON_DATA(EVENT_CONNECTION);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		STOP_ME;
	}

	I_AM_ALIVE;


	STOP_ME;
	return 0;
}

// Il formato dei parametri e' il seguente:
// Azione da triggerare a processo TERMINATO (TRIGGER_ACTION(myData->pParams))
// Tipo di ricerca da fare (window title [1] o nome del processo [0])
// Nome del processo in WCHAR NULL-terminato
// Abbiamo un thread per processo, tuttavia il thread e' estremamente lightweight poiche'
// effettua solo un busy-cycle, il resto viene fatto tutto dalla classe singleton Process.
DWORD WINAPI OnProcess(LPVOID lpParam) {
	COMMON_DATA(EVENT_PROCESS);
	UINT uTerminate, uType;
	WCHAR *wName = NULL;
	BOOL bActive = FALSE;

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	Process *processObj = Process::self();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL || processObj == NULL) {
		STOP_ME;
	}

	I_AM_ALIVE;

	// Azione da triggerare a processo TERMINATO
	memcpy(&uTerminate, myData->pParams, sizeof(uTerminate));

	// Il tipo sara' a 1 se dobbiamo cercare il titolo della finestra, 
	// a 0 se dobbiamo cercare il nome del processo.
	memcpy(&uType, (BYTE *)(myData->pParams) + 4, sizeof(uType));

	// Prendiamo il puntatore al nome del processo/finestra
	wName = (WCHAR *)((BYTE *)(myData->pParams) + 8);

	if(wName == NULL) {
		STOP_ME;
		return 0;
	}

	LOOP {
		switch(uType) {
			case 0: // Processo
				if(bActive == TRUE && processObj->IsProcessRunning(wName) == FALSE) {
					bActive = FALSE;

					if(uTerminate != CONF_ACTION_NULL) {
						TRIGGER_ACTION(uTerminate); // Processo terminato
					}
				} else if(bActive == FALSE && processObj->IsProcessRunning(wName) == TRUE) {
					bActive = TRUE;
					TRIGGER_ACTION(myData->uActionId); // Processo attivo
				}

				break;

			case 1: // Finestra
				if(bActive == TRUE && processObj->IsWindowPresent(wName) == FALSE) {
					bActive = FALSE;

					if(uTerminate != CONF_ACTION_NULL) {
						TRIGGER_ACTION(uTerminate); // Finestra distrutta
					}
				} else if(bActive == FALSE && processObj->IsWindowPresent(wName) == TRUE) {
					bActive = TRUE;
					TRIGGER_ACTION(myData->uActionId); // Finestra creata
				}

				if(uTerminate != CONF_ACTION_NULL) {

				}
				break;

			default: 
				break;
		}

		Sleep(1000);
		CHECK_FOR_STOP;
	}

	STOP_ME;
	return 0;
}